package org.bitbucket.bradleysmithllc.webserviceshubclient.regexp;

/*

		Regular expression class compiled by the Regular Expression Compiler 1.5.0-SNAPSHOT

*/

import java.util.Map;
import java.util.HashMap;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public final class ScopeExpression
{
	public static final String PATTERN_RAW_TEXT = "(?'global'\\[Global\\])[\\s]*[\\s]*[\\s]*|[\\s]*[\\s]*[\\s]*(\\[(?'session'[^\\]\\.:]+)\\])[\\s]*[\\s]*[\\s]*|[\\s]*[\\s]*[\\s]*(\\[(?'folderSession'(?'folderName'[^\\]:]+)\\.(?'folderSessionName'[^\\]:]+))\\])[\\s]*[\\s]*[\\s]*|[\\s]*[\\s]*[\\s]*([\\s]*[\\s]*[\\s]*[\\s]*\\[[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(?'integrationService'Service:[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(?'serviceName'[^\\]\\.]+)[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(\\.ND:[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(?'nodeName'[^\\]\\.:]+)[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*)?[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*)[\\s]*[\\s]*[\\s]*[\\s]*\\][\\s]*[\\s]*[\\s]*)[\\s]*[\\s]*[\\s]*|[\\s]*[\\s]*[\\s]*([\\s]*[\\s]*[\\s]*[\\s]*\\[[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(?'qualifiedWorkflowSession'[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(?'qualifiedFolderName'[^\\]\\.]+)[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*\\.WF:[\\s]*(?'workflowName'[^\\]\\.:]+)[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(\\.WT:[\\s]*(?'workletName'[^\\]\\.:]+))?[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*(\\.ST:[\\s]*(?'sessionName'[^\\]\\.:]+))?[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*[\\s]*)[\\s]*[\\s]*[\\s]*[\\s]*\\][\\s]*[\\s]*[\\s]*)[\\s]*[\\s]*[\\s]*|[\\s]*[\\s]*[\\s]*(?'scope'Crap)";
	public static final String PATTERN_TEXT;
	public static final Pattern pattern;
	private static final Map<String, Integer> groupOffsets = new HashMap<String, Integer>();

	private final Matcher matcher;
	private final CharSequence matchText;

	public static interface RegExpIterator
	{
		String replaceMatch(ScopeExpression e);
	}

	static
	{
		PATTERN_TEXT = PATTERN_RAW_TEXT.replaceAll("\\(\\?'[^']+'", "(");

		Pattern cpattern = Pattern.compile("(\\\\)?\\((\\?'([^']+)')?");

		Matcher matcher = cpattern.matcher(PATTERN_RAW_TEXT);

		int groupCount = 1;

		while (matcher.find())
		{
			if (matcher.group(1) != null)
			{
				continue;
			}

			String groupName = matcher.group(3);

			if (groupName != null)
			{
				groupOffsets.put(groupName, new Integer(groupCount));
			}

			groupCount++;
		}

		pattern = Pattern.compile(PATTERN_TEXT, Pattern.CASE_INSENSITIVE | Pattern.MULTILINE);
	}


	private ScopeExpression(Matcher pMatcher, CharSequence ch)
	{
		matcher = pMatcher;
		matchText = ch;
	}

	public ScopeExpression(CharSequence ch)
	{
		this(pattern.matcher(ch), ch);
	}

	public static ScopeExpression match(CharSequence pText)
	{
		return new ScopeExpression(pText);
	}

	public int end()
	{
		return matcher.end();
	}

	public int end(int group)
	{
		return matcher.end(group);
	}

	public int start()
	{
		return matcher.start();
	}

	public int start(int group)
	{
		return matcher.start(group);
	}

	public String replaceAll(String replacement)
	{
		return matcher.replaceAll(replacement);
	}

	public String replaceAll(RegExpIterator it)
	{
		String match = matchText.toString();
		String str = "";
		int end = -1;

		while (hasNext())
		{
			str += match.substring(end == -1 ? 0 : end, start());
			str += it.replaceMatch(this);
			end = end();
		}

		str += match.substring(end == -1 ? 0 : end, match.length());
		return str;
	}

	public boolean matches()
	{
		return matcher.matches();
	}

	public boolean hasNext()
	{
		return matcher.find();
	}

	public int groupCount()
	{
		return matcher.groupCount();
	}

	public String group()
	{
		return matcher.group();
	}

	public String group(int i)
	{
		return matcher.group(i);
	}

	public ScopeExpression resetMatch(CharSequence seq)
	{
		return match(seq);
	}

	public String group(String name)
	{
		return matcher.group(groupOffsets.get(name).intValue());
	}

	private static String scope(String text, String name)
	{
		return text.replaceAll("(\\(\\?')(\\w+')", "$1" + name + ".$2");
	}


	public boolean hasGlobal()
	{
		return group("global") != null;
	}

	public String getGlobal()
	{
		if (!hasGlobal())
		{
			throw new IllegalArgumentException("Property not defined: Global");
		}
		return group("global");
	}

	public boolean hasSession()
	{
		return group("session") != null;
	}

	public String getSession()
	{
		if (!hasSession())
		{
			throw new IllegalArgumentException("Property not defined: Session");
		}
		return group("session");
	}

	public boolean hasFolderSession()
	{
		return group("folderSession") != null;
	}

	public String getFolderSession()
	{
		if (!hasFolderSession())
		{
			throw new IllegalArgumentException("Property not defined: FolderSession");
		}
		return group("folderSession");
	}

	public boolean hasFolderName()
	{
		return group("folderName") != null;
	}

	public String getFolderName()
	{
		if (!hasFolderName())
		{
			throw new IllegalArgumentException("Property not defined: FolderName");
		}
		return group("folderName");
	}

	public boolean hasFolderSessionName()
	{
		return group("folderSessionName") != null;
	}

	public String getFolderSessionName()
	{
		if (!hasFolderSessionName())
		{
			throw new IllegalArgumentException("Property not defined: FolderSessionName");
		}
		return group("folderSessionName");
	}

	public boolean hasIntegrationService()
	{
		return group("integrationService") != null;
	}

	public String getIntegrationService()
	{
		if (!hasIntegrationService())
		{
			throw new IllegalArgumentException("Property not defined: IntegrationService");
		}
		return group("integrationService");
	}

	public boolean hasServiceName()
	{
		return group("serviceName") != null;
	}

	public String getServiceName()
	{
		if (!hasServiceName())
		{
			throw new IllegalArgumentException("Property not defined: ServiceName");
		}
		return group("serviceName");
	}

	public boolean hasNodeName()
	{
		return group("nodeName") != null;
	}

	public String getNodeName()
	{
		if (!hasNodeName())
		{
			throw new IllegalArgumentException("Property not defined: NodeName");
		}
		return group("nodeName");
	}

	public boolean hasQualifiedWorkflowSession()
	{
		return group("qualifiedWorkflowSession") != null;
	}

	public String getQualifiedWorkflowSession()
	{
		if (!hasQualifiedWorkflowSession())
		{
			throw new IllegalArgumentException("Property not defined: QualifiedWorkflowSession");
		}
		return group("qualifiedWorkflowSession");
	}

	public boolean hasQualifiedFolderName()
	{
		return group("qualifiedFolderName") != null;
	}

	public String getQualifiedFolderName()
	{
		if (!hasQualifiedFolderName())
		{
			throw new IllegalArgumentException("Property not defined: QualifiedFolderName");
		}
		return group("qualifiedFolderName");
	}

	public boolean hasWorkflowName()
	{
		return group("workflowName") != null;
	}

	public String getWorkflowName()
	{
		if (!hasWorkflowName())
		{
			throw new IllegalArgumentException("Property not defined: WorkflowName");
		}
		return group("workflowName");
	}

	public boolean hasWorkletName()
	{
		return group("workletName") != null;
	}

	public String getWorkletName()
	{
		if (!hasWorkletName())
		{
			throw new IllegalArgumentException("Property not defined: WorkletName");
		}
		return group("workletName");
	}

	public boolean hasSessionName()
	{
		return group("sessionName") != null;
	}

	public String getSessionName()
	{
		if (!hasSessionName())
		{
			throw new IllegalArgumentException("Property not defined: SessionName");
		}
		return group("sessionName");
	}

	public boolean hasScope()
	{
		return group("scope") != null;
	}

	public String getScope()
	{
		if (!hasScope())
		{
			throw new IllegalArgumentException("Property not defined: Scope");
		}
		return group("scope");
	}

	public String toString()
	{
		return "{ScopeExpression, matchText='" + matchText + "'}[" + "(global)=" + (hasGlobal() ? getGlobal() : "null") + ", (session)=" + (hasSession() ? getSession() : "null") + ", (folderSession)=" + (hasFolderSession() ? getFolderSession() : "null") + ", (folderName)=" + (hasFolderName() ? getFolderName() : "null") + ", (folderSessionName)=" + (hasFolderSessionName() ? getFolderSessionName() : "null") + ", (integrationService)=" + (hasIntegrationService() ? getIntegrationService() : "null") + ", (serviceName)=" + (hasServiceName() ? getServiceName() : "null") + ", (nodeName)=" + (hasNodeName() ? getNodeName() : "null") + ", (qualifiedWorkflowSession)=" + (hasQualifiedWorkflowSession() ? getQualifiedWorkflowSession() : "null") + ", (qualifiedFolderName)=" + (hasQualifiedFolderName() ? getQualifiedFolderName() : "null") + ", (workflowName)=" + (hasWorkflowName() ? getWorkflowName() : "null") + ", (workletName)=" + (hasWorkletName() ? getWorkletName() : "null") + ", (sessionName)=" + (hasSessionName() ? getSessionName() : "null") + ", (scope)=" + (hasScope() ? getScope() : "null") + "]";
	}

	public static void main(String [] argv)
	{
		System.out.println(PATTERN_TEXT);
	}
}